      subroutine doubleker(bcarr1,bcarr2,dim1,dim2,bandwidth,tt,ker)
      implicit none
      real, intent(in), dimension(dim1,4) :: bcarr1
      real, intent(in), dimension(dim2,4) :: bcarr2
      real :: ker, kers0, bandwidth, tt, pdf1, pdf2
      integer :: dim1, dim2, i, j
      ker=0
      kers0=0
      do i=1,dim1
         do j=1,dim2
         if (bcarr2(j,1)==bcarr1(i,1)) then
              if (abs(tt-bcarr1(i,2)) <= bandwidth) then 
                     pdf1 = (1-((tt-bcarr1(i,2))/bandwidth)**2)*3/4
                      else 
                         pdf1 = 0
                    end if
              if (abs(tt-bcarr2(j,2)) <= bandwidth) then 
                     pdf2 = (1-((tt-bcarr2(j,2))/bandwidth)**2)*3/4 
                      else 
                         pdf2 = 0
                    end if
      ker = ker + pdf1/bandwidth*bcarr1(i,3)*pdf2/bandwidth*bcarr2(j,3)
      kers0 = kers0 + pdf1/bandwidth*pdf2/bandwidth
         end if
         end do
      end do
      ker=ker/kers0
      if (kers0==0) then 
           ker=0
      end if
      end subroutine doubleker
      
      subroutine kernel(bcarr,dim,bandwidth,tt,ker)
      implicit none
      real, intent(in), dimension(dim,4) :: bcarr
      real :: ker, kers0, bandwidth, tt, pdf
      integer :: dim, i
      ker=0
      kers0=0
      do i=1,dim
        if (abs(tt-bcarr(i,2)) <= bandwidth) then 
            pdf = (1-((tt-bcarr(i,2))/bandwidth)**2)*3/4
                else 
                    pdf = 0
        end if
      ker = ker + pdf/bandwidth*bcarr(i,3)
      kers0 = kers0 + pdf/bandwidth
      end do
      ker=ker/kers0
      if (kers0==0) then 
           ker=0
      end if
      end subroutine kernel